LINUX.ORG.RU

Интервью с разработчиком DeaDBeeF

 , , ,


0

0

Участились случаи появления в интернете записей типа «DeaDBeeF — наше всё». С анонимусами не поспоришь. Надобно самому правду-матушку отыскать. А у кого ж секреты выведать, как не у отца-родоначальника? Усаживайтесь поудобнее и читайте беседу с Алексеем Яковенко, тем самым автором.

Небольшое интервью с отцом-основателем и главным разработчиком аудиоплеера DeaDBeeF - Алексеем Яковенко. Какие цели преследовались при создание проекта,в каком направлении будет развиваться плеер, чего ждать в скором релизе версии 0.5 и ответы на многие другие вопросы вы узнаете, прочитав данное интервью.

>>> Подробности

★★★★★

Проверено: Shaman007 ()

На мой взгляд - идеальный плеер. Жрет все, что предложишь, не имеет жестской привязки к гуям. Сделал себе небольшой гуй на Qt - никаких проблем больше ни с чем. Для Кде больше вариантов приличных вообще нет.

LightDiver ★★★★★ ()
Ответ на: комментарий от anonymous

у меня там зоопарк кодировок, и заниматься усиленно всякими перекодировками лень. в системе все кодировки есть, опенофис кушает, а вот музикплееры ни один по человечески никак. шоманить и править коньфиги тоже сил нет

sudoer ()
Ответ на: комментарий от anonymous

>UTF-8 сейчас держат все линуксовые плееры

ивритские огласовки неподдерживаются. а иногда это много значит:)

sudoer ()
Ответ на: комментарий от waker

> они ждут, что я каким-то образом протолкну все свои патчи в апстрим, после чего магическим образом сделаю так, что все дистрибутивы обновятся до последних версий нужных библиотек (иногда из git/cvs/svn), и все замечательно заработает.

Если бы я собирал ваш проект в Debian, то я бы тоже этого ждал. Если каждая программа будет с собой тянуть патченые версии библиотек, то смысла в дистрибутиве мало. Если завтра в одной из таких библиотек найдут security-ошибку, как вы предлагаете её обновлять?

JackYF ★★★★ ()
Ответ на: комментарий от JackYF

>> они ждут, что я каким-то образом протолкну все свои патчи в апстрим, после чего магическим образом сделаю так, что все дистрибутивы обновятся до последних версий нужных библиотек (иногда из git/cvs/svn), и все замечательно заработает.

Если бы я собирал ваш проект в Debian, то я бы тоже этого ждал.


Уточнение: ждал бы чистой сборки без bundle'ов, минимальных версий библиотек, с которыми линковаться и проталкивания патчей.

JackYF ★★★★ ()

DLNA уже умеет? Нет? Тогда закапывайте, люди всё же в 2011 году уже живут.

Mr_Alone ★★★★★ ()

Как-то слишком пафосно для очередного велосипеда.

Fredrik ()

Скачал, запустил, стартовал мп3. Что ж, хорошая работа :-)

Deleted ()
Ответ на: комментарий от Fredrik

Как-то слишком пафосно для очередного велосипеда.

Это единственный реально и бепроблемно работающий плеер. Сейчас уже складываетя ситуация, что ему альтернатив попросту нет. По крайней мере я не знаю. Разве что мпд и аудишс, но у них есть отдельные проблемы, отсутствующие в этом. Например аудишс привязан к гтк.

LightDiver ★★★★★ ()
Ответ на: комментарий от MyFreedom

Хочу сменить музыку.

1. Открыть ФМ - найти музыку - достать из трея плейер (или сменить стол) - перетащить музыку

2. Достать из трея - перетащить музыку

Не видно разницы?

Первые 2 варианта не кошерны

Нужно срочно написать плагин для libastral.so

daemontux ()
Ответ на: комментарий от JackYF

> Если завтра в одной из таких библиотек найдут security-ошибку, как вы предлагаете её обновлять?

я задам встречный вопрос. если завтра в одной из библиотек мне понадобится исправить баг, из-за которого моя программа вылетает — как вы предлагаете это делать?

waker ★★★★★ ()
Ответ на: комментарий от waker

поверьте, как только эти библиотеки будут работать без затачивания напильником под каждый проект, иметь стабильный API/ABI, и будут доступны во всех дистрибутивах — я сразу перестану их бандлить.

waker ★★★★★ ()
Ответ на: комментарий от waker

>если завтра в одной из библиотек мне понадобится исправить баг, из-за которого моя программа вылетает

как вы предлагаете это делать?


[ Я предполагаю, что доступен патч, исправляющий ошибку, иначе вариантов нет никаких (кроме хаков) ]

1. пишете в список зависимостей: «libbuggy (>= 1.2.7+svn1108), либо libbuggy (>= 1.1.0) с патчем (ссылка на патч/коммит)»
2а. Дистрибутив накладывает патч на дистрибутивную библиотеку.
2б. Дистрибутив обновляет библиотеку на версию из svn/git/...
2в. Дистрибутив ждёт, пока libbuggy выпустит новый релиз.

tl;dr: вы указываете, что надо вашей программе и предоставляете дистрибутивам выбрать, как это обеспечить.

JackYF ★★★★ ()
Ответ на: комментарий от waker

>оные правила ставят удобство мейнтейнеров пакетов / дистрибутива выше, чем качество программы. я не собираюсь жертвовать качеством, только потому, что чтобы мейнтейнеру пакета надо поставить галочку в правилах.

Хорошо, что не все такие самолюбивые. Иначе бы у нас вообще бы не было дистрибутивов как таковых. И вопрос в догонку: а почему бы самому не мейнтейнить пакеты? (это не призыв, конечно, каждый волен делать ТО, что ОН хочет, и никому ничего не должен). Просто как продолжение к Вашему ответу.

mpp5 ()
Ответ на: комментарий от waker

>и будут доступны во всех дистрибутивах

Такого не бывает :)

как только эти библиотеки будут работать без затачивания напильником под каждый проект, иметь стабильный API/ABI


Если библиотека требует затачивая под каждый проект, то это плохо написанная библиотека. Нужны ли вам такие в зависимостях?

Про API/ABI отдельный разговор, да, нужно смотреть каждую библиотеку конкретно.

JackYF ★★★★ ()

Могу ошибаться, в deadbeef нет import/export m3u (m3u8) плейлистов. В меня сохранения я этого не нашел ;(

FiXer ★★☆☆☆ ()
Ответ на: комментарий от sudoer

> в наутилусе не сбивается:)

Потому что наутилус отображает имена файлов, которые в юникоде, а плеер читает теги, которые непонятно в какой кодировке (cpXXXX?).

Сделайте так: удалите в DeadBeef столбец с названием трека и добавьте пользовательский стобец с форматом %f. Будет как в наутилусе.

bloodredfrog ★★ ()
Ответ на: комментарий от bloodredfrog

опа, сработало!. а , простите за наг;ость, имя альмома также сделать можно?:)

sudoer ()
Ответ на: комментарий от sudoer

Нет. Так как в данном случае %f просто выводит имя файла.

Если музыка у вас разложена по каталогам, названия которых соответствуют названиям альбомов, можно выводить название каталога по %d.

bloodredfrog ★★ ()
Ответ на: комментарий от mpp5

> И вопрос в догонку: а почему бы самому не мейнтейнить пакеты?

для всех дистрибутивов? а когда же deadbeef делать? :)

waker ★★★★★ ()
Ответ на: комментарий от bloodredfrog

мда... полюбому придется осиливать изитаг.. у меня напев под именем פיה פתחה прусудствует у 11 исполнтелей в 16 альбомах:) спасибо, в любом случае, частичный результ- алсо результ:)

sudoer ()
Ответ на: комментарий от JackYF

> Если библиотека требует затачивая под каждый проект, то это плохо написанная библиотека. Нужны ли вам такие в зависимостях?

надеюсь, вы не обидитесь, если я не буду отвечать на этот вопрос. просто не могу найти ответа, и не могу понять смысла вопроса.

waker ★★★★★ ()
Ответ на: комментарий от FiXer

> Могу ошибаться, в deadbeef нет import/export m3u (m3u8) плейлистов.

в 0.5 уже есть.

waker ★★★★★ ()

Отличный плеер. Довольно давно его использую. Перешёл на него с musicpd. Проблема была в том, что было масса flac-файлов, а musicpd их зараза не умеет на треки разбивать в соответствии с cue-файлом. Долго ждал появление этого функционала, но потом надоело и решился поставить DeaDBeeF, который тогда уже достаточно вырос (помню анонс на ЛОРе первой версии ещё). Всё заработало из коробки. А потом ещё и переход с FreeBSD на Ubuntu у меня был. Вот тогда я замучился с musicpd, который тупо блокировал звук или ничего не мог воспроизвести. Сабж это всё делал без проблем. Автору большое спасибо! Ждём перекодирование музыки (приходится сейчас через foobar2000 делать под VirtualBox когда хочу музыку на телефон скинуть).

Feonis ★★ ()
Ответ на: комментарий от waker

>> Если библиотека требует затачивая под каждый проект, то это плохо написанная библиотека. Нужны ли вам такие в зависимостях?

надеюсь, вы не обидитесь, если я не буду отвечать на этот вопрос. просто не могу найти ответа, и не могу понять смысла вопроса.


Нет, не обижусь — это был риторический вопрос.

JackYF ★★★★ ()
Ответ на: комментарий от waker

Тихо и незаметно ваш плеер стал основным в системе. Спасибо за разработку.

Вопрос не в тему - каким дистрибутивом сейчас пользуетесь?

vadik ★★ ()
Ответ на: комментарий от JackYF

1. пишете в список зависимостей: «libbuggy (>= 1.2.7+svn1108), либо libbuggy (>= 1.1.0) с патчем (ссылка на патч/коммит)»


в итоге сборка пакета превратится в процесс, который не смогу осилить даже я сам. а уж пользователи-то как обрадуются :)

я так и представляю файл INSTALL, в котором 50 страничное руководство из каких svn'ов качать исходники библиотек, откуда патчи, и т.п.

а потом посередине оказывается что один из патчей с хостинга удалили.


2а. Дистрибутив накладывает патч на дистрибутивную библиотеку.


как узнать какая в дистрибутиве версия библиотеки? что делать если в дистрибутиве библиотека меньшей или большей версии, чем надо? что делать если библиотеки вообще нет ни в одном дистрибутиве? что делать, если мои патчи полностью изменяют API библиотеки, и, как результат, ломают ее совместимость со всеми остальными приложениями?

это все равно приведет к созданию нескольких различных несовместимых друг с другом версий одних и тех же библиотек, и усложнит жизнь всем еще больше.

2б. Дистрибутив обновляет библиотеку на версию из svn/git/...


с какой стати им это делать?

2в. Дистрибутив ждёт, пока libbuggy выпустит новый релиз.

tl;dr: вы указываете, что надо вашей программе и предоставляете дистрибутивам выбрать, как это обеспечить.


а пользователи в этом время ждут пока рак на горе свиснет

вам самому не кажется, что это какой-то бессмысленный фанатизм, не имеющий никакого отношения ни к интересам пользователей, ни к интересам разработчиков?
вы, случайно, не имеете отношения к проекту debian?

waker ★★★★★ ()
Ответ на: комментарий от vadik

> Вопрос не в тему - каким дистрибутивом сейчас пользуетесь?

в данный момент арч.

waker ★★★★★ ()
Ответ на: комментарий от waker

Еще вопросик. Ни в справке к программе, ни при беглом гуглении не нашел адрес форума посвященного deadbeef - такой вообще существует (в идеале хотелось бы русскоязычный)?

vadik ★★ ()

waker, продолжай пилить, годный плеер. А лоровцам только дай повод достать лопаты :)

Minoru ★★★ ()
Ответ на: комментарий от waker

А где можно в случае проблем вопросы задавать?

vadik ★★ ()
Ответ на: комментарий от waker

А как все остальные разработчики умудряются писать свои плееры и включать их в дистрибутивы в таком жестоком и несправедливом мире?

Oleaster ★★★ ()
Ответ на: комментарий от vadik

> А где можно в случае проблем вопросы задавать?

irc, email, support request tracker @ sf.net

waker ★★★★★ ()
Ответ на: комментарий от waker

>я так и представляю файл INSTALL, в котором 50 страничное руководство из каких svn'ов качать исходники библиотек, откуда патчи, и т.п.

А что так много? Вы нашли в библиотеках столько ошибок, из-за которых ваш проект падает, что требуется 50 страниц, чтобы перечислить ссылки на все патчи?

как узнать какая в дистрибутиве версия библиотеки?


Вам-то какая разница? Не вы пакеты собираете, а дистрибутив.

2б. Дистрибутив обновляет библиотеку на версию из svn/git/...

с какой стати им это делать?


Например, чтобы собрать новый deadbeef. Для хорошей программы не жалко.

а пользователи в этом время ждут пока рак на горе свиснет


Да, пользователи ждут.

что делать, если мои патчи полностью изменяют API библиотеки, и, как результат, ломают ее совместимость со всеми остальными приложениями?


Это уже сложно назвать патчем, это на полноценный форк тянет. У меня-таки складывается впечатление, что библиотеки выбраны неудачно. И падают, и API приходится переделывать...

вам самому не кажется, что это какой-то бессмысленный фанатизм, не имеющий никакого отношения ни к интересам пользователей, ни к интересам разработчиков?


Нет, не кажется. В интересах пользователей и сторонних разработчиков иметь одну версию библиотеки, а не много. В долгосрочных интересах пользователей и сопровождающих иметь также меньшего размера тарболл, меньшее время сборки, более чистые диффы для параноиков.

вы, случайно, не имеете отношения к проекту debian?


Случайно имею, см. мой профиль.

Итак, на ваш вопрос про библиотеки я ответил, хоть ответ вас и не устраивает. Вернёмся к моему вопросу про security-ошибки в bundle'ах, как вы предлагаете их исправлять? Подождать новую версию хорошей программы неделю можно, а security-ошибки столько ждать не могут.

JackYF ★★★★ ()
Ответ на: комментарий от Oleaster

> А как все остальные разработчики умудряются писать свои плееры и включать их в дистрибутивы в таком жестоком и несправедливом мире?

наверное, это лучше спрашивать у разработчиков других плееров. я не задавался этим вопросом.

waker ★★★★★ ()

Чем-то он «неуловимо» напоминает фубар.

TGZ ★★★★ ()
Ответ на: комментарий от JackYF

Да, пользователи ждут.


меня это не устраивает. поэтому я делаю бинарные билды. а те кому нравится ждать - пусть ждут.

Это уже сложно назвать патчем, это на полноценный форк тянет.


так и есть. но т.к. я не соизволил опубликовать эти форки в виде отдельных проектов - это вызывает резонанс.

библиотеки выбраны неудачно


выбора особо нет. либо эти, либо никаких.

Случайно имею, см. мой профиль.


это многое объясняет.

как вы предлагаете их исправлять?


1. найти уязвимость
2. исправить

а если серьезно, если вас беспокоит security - советую удалить все плееры с вашего компьютера. особенно с поддержкой экзотических форматов (через библиотеки типа adplug). там переполнений буфера и срывов стека больше, чем пользователей у дебиана.

waker ★★★★★ ()
Ответ на: комментарий от vadik

> Для irc сервер не подскажете?

google->freenode

я наизусть не помню.

waker ★★★★★ ()
Ответ на: комментарий от JackYF

вобщем, я от этого обмена любезностями уже порядком устал.. пусть администраторы дебиана сами решат, что им удобнее. если проект не подходит по правилам — значит не подходит. у меня это не вызывает никакой реакции. меня раздражает только назойливость каждого очередного мейнтейнера, который как бы и хочет в дебиан пакет сделать, и не может. сами себя в рамки загнали - а я виноват. пусть идут лесом.

waker ★★★★★ ()
Вы не можете добавлять комментарии в эту тему. Тема перемещена в архив.